CPU_control: process (ST, rst_b, opd, mode, IRQ, SCint, CCR, MAR, X, PC, Md)
   variable reg_mem, hw_interrupt, BR : boolean;
begin
nST <= reset; BR := FALSE; wr <= '0'; update <= '0';
xadd1 <= (others => '0'); xadd2 <= (others => '0'); va <= "000";
db2A <= '0'; db2X <= '0'; db2Md <= '0'; db2CCR <= '0'; db2opcode <= '0'; 
...   (all control signals are set to '0' here)

reg_mem:= (mode = imm) or (mode = dir) or (mode = ext) or (mode = ix) or 
   		(mode = ix1) or (mode = ix2);
hw_interrupt := (I = '0') and (IRQ = '1' or SCint = '1');

if (rst_b = '0') then nST <= reset;
else
case ST is
when reset =>
	setSP <= '1'; 
	if (rst_b = '1') then nST <= cycle8; end if;
when fetch => 
	if (reg_mem and JMP = '0' and JSR = '0')
		then update <= '1'; end if; -- update registers if not JMP or JSR
 	if hw_interrupt then nST <= push1;
		else PC2ab<='1'; db2opcode<='1'; incPC<='1';	-- read opcode
			nST <= addr1; end if;

when addr1 =>
case mode is 
	when inha | inhx => update <= '1'; nST<= fetch;
	when imm => PC2ab<= '1'; db2Md<='1'; incPC<='1';
		nST <= fetch;
	when inh1 =>
		if SWI = '1' then nST <= push1;
		elsif RTS = '1' then nST <= pop2; incSP<='1';
		elsif RTI = '1' then nST <= pop5; incSP<='1';
		end if;
	when inh2 => update <= '1'; nST <= fetch;
	when dir =>  PC2ab<='1';
		if JMP='1' then db2PCL<='1'; clrPCH<='1'; nST<=fetch;
   	else db2MARL<='1'; clrMARH<='1'; incPC <= '1';
			if JSR='1' then nST<=push1; else nST<=data; end if;
		end if;
	...   (remainder of process omitted -- see Appendix E)

